Attribute VB_Name = "Modul"
'NIKI in Visual Basic
'(c) Albert Zeyer

'alle Richtungsangaben in diesem Programm
'sind folgendermaen definiert:
' eine Integer-Zahl
'  1 - oben (Standard)
'  2 - rechts
'  3 - unten
'  4 - links

Option Explicit

Type POINTAPI
 x As Long
 y As Long
End Type

Type FormK
 Left As Long
 Top As Long
 Width As Long
 Height As Long
 Modus As Integer
End Type

Global Verz As String
Global PersNIKI(0 To 9, 0 To 9) As Boolean
Global EinPunkt(0 To 9, 0 To 9) As Boolean
Global BildTr1(0 To 9, 0 To 9) As Boolean
Global BildTr2(0 To 9, 0 To 9) As Boolean
Global EditorEnde As Boolean
'True  - Speichern
'False - Abbruch (oder geschlossen)
Global TempBild(0 To 9, 0 To 9) As Boolean
Global EditorCaption As String
Global HauptformK As FormK
Global ProgrammK As FormK
Global BedienungK As FormK
Global EditorBedienungK As FormK

'Ab hier kommen alle Deklarationen,
'die fr das Programm selber, fr
'die Scriptsprache und fr die Anzeige
'wichtig sind:
Type Mchen
 Richtung As Integer
 Standort As POINTAPI
 AnzPunkte As Integer
End Type
Type Zl
 Standort As Boolean
 DataStandort As POINTAPI
 Punkte As Boolean
 DataPunkte As Integer
 NewRaum As Boolean
 DataNewRaum As String
End Type
Type HauptType
 Mnnchen As Mchen
 Ziel As Zl
End Type
Global MainData As HauptType

'Die Programmcodeausfhrung
Type OneCodeLine
 Text As String
 StartZeichen As Long
 EndZeichen As Long
End Type
Global AnzFunktionen As Integer
Global FunktionenName(1 To 100) As String
Global AnzFunktionenParameters(1 To 100) As Integer
Global FunktionenParameters(1 To 100, 1 To 10) As String
Global AnzFunktionenLine(1 To 100) As Integer
Global FunktionenLineInhalt(1 To 100, 1 To 1000) As OneCodeLine
Global AnzLineCode As Integer
Global LineCode(1 To 1000) As OneCodeLine
Global AnzArrays As Integer
Global ArraysName(1 To 100) As String
Global AnzVariablen As Integer
Global VariablenName(1 To 100) As String
Global VariablenInhalt(1 To 100) As Long
Global AnzReferenzen As Integer
Global ReferenzenName(1 To 100) As String
Global ReferenzenInhalt(1 To 100) As Integer
Type BS
 Linie As Integer
 Block As Integer 'die Funktion
 AnzVariablen As Integer
End Type
Global AnzBlockStapel As Integer
Global BlockStapel(1 To 100) As BS
Global BlockVariablenInhalt(1 To 100, 1 To 10) As Long

'** Deklarationen fr Bitmap-Routinen
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Global Const SRCCOPY = &HCC0020

'** Deklarationen fr Desktop-Ermittlung
Declare Function GetDesktopWindow Lib "user32" () As Long
Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Sub Main()
 If App.PrevInstance Then
  MsgBox "Das Programm kann nicht mehrmals gestartet werden.", , "Fehler"
  End
 End If
 Verz = App.Path
 Verz = Verz + IIf(Right$(Verz, 1) = "\", "", "\")
 If Schreibtest() = False Then
  MsgBox "Das Programm wird von einem schreibgeschtzten Datentrger aus gestartet. Kopieren sie die Programmdateien auf die Festplatte und starten sie das Programm erneut. Falls der selbe Fehler auftritt, entfernen sie alle Attribute der Programmdateien.", , "Fehler"
  End
 End If
 Dim FileNum%
 Dim x As Integer
 Dim y As Integer
 Dim Temp As String
 For x = 0 To 9
  For y = 0 To 9
   TempBild(x, y) = False
   PersNIKI(x, y) = False
   BildTr1(x, y) = False
   BildTr2(x, y) = False
   EinPunkt(x, y) = False
  Next
 Next
 MainData.Mnnchen.AnzPunkte = 0
 MainData.Mnnchen.Richtung = 1
 MainData.Mnnchen.Standort.x = 0
 MainData.Mnnchen.Standort.y = 19
 MainData.Ziel.NewRaum = False
 MainData.Ziel.Punkte = True
 MainData.Ziel.Standort = True
 MainData.Ziel.DataNewRaum = ""
 MainData.Ziel.DataPunkte = 1
 MainData.Ziel.DataStandort.x = 0
 MainData.Ziel.DataStandort.y = 19
 If Dir$(Verz + "NIKI.Dat") = "" Then
  MsgBox "NIKI wurde nicht gefunden. Sie mssen NIKI erst zeichnen, um in anzeigen zu knnen. Bitte zeichnen sie jetzt NIKI.", , "Fehler"
  If EditNIKI() = False Then End
 Else
  FileNum% = FreeFile
  Open Verz + "NIKI.Dat" For Input As FileNum%
  For x = 0 To 9
   Line Input #FileNum%, Temp
   For y = 0 To 9
    PersNIKI(x, y) = (Mid$(Temp, y + 1, 1) = "1")
   Next
  Next
  Close FileNum%
 End If
 If Dir$(Verz + "Punkt.Dat") = "" Then
  MsgBox "Das Bild von einem Punkt wurde nicht gefunden. Sie mssen den Punkt erst zeichnen, um in anzeigen zu knnen. Bitte zeichnen sie jetzt den Punkt.", , "Fehler"
  If EditPunkt() = False Then End
 Else
  FileNum% = FreeFile
  Open Verz + "Punkt.Dat" For Input As FileNum%
  For x = 0 To 9
   Line Input #FileNum%, Temp
   For y = 0 To 9
    EinPunkt(x, y) = (Mid$(Temp, y + 1, 1) = "1")
   Next
  Next
  Close FileNum%
 End If
 If Dir$(Verz + "Tr1.Dat") = "" Then
  MsgBox "Die erste Tr wurde nicht gefunden. Sie mssen die Tr erst zeichnen, um sie anzeigen zu knnen. Bitte zeichnen sie jetzt die erste Tr (mindestens ein Punkt um zu passieren).", , "Fehler"
  If EditTr1() = False Then End
 Else
  FileNum% = FreeFile
  Open Verz + "Tr1.Dat" For Input As FileNum%
  For x = 0 To 9
   Line Input #FileNum%, Temp
   For y = 0 To 9
    BildTr1(x, y) = (Mid$(Temp, y + 1, 1) = "1")
   Next
  Next
  Close FileNum%
 End If
 If Dir$(Verz + "Tr2.Dat") = "" Then
  MsgBox "Die zweite Tr wurde nicht gefunden. Sie mssen die Tr erst zeichnen, um sie anzeigen zu knnen. Bitte zeichnen sie jetzt die zweite Tr (KEIN Punkt um zu passieren).", , "Fehler"
  If EditTr2() = False Then End
 Else
  FileNum% = FreeFile
  Open Verz + "Tr2.Dat" For Input As FileNum%
  For x = 0 To 9
   Line Input #FileNum%, Temp
   For y = 0 To 9
    BildTr2(x, y) = (Mid$(Temp, y + 1, 1) = "1")
   Next
  Next
  Close FileNum%
 End If
 Hauptform.Show
 Hauptform.StartTimer_Timer
 Programm.Show
 Bedienung.Show
 Bedienung.Programmstopp
 If LoadForms() Then
  Hauptform.Left = HauptformK.Left
  Hauptform.Top = HauptformK.Top
  Programm.Tag = "1"
  Programm.Left = ProgrammK.Left
  Programm.Tag = "1"
  Programm.Top = ProgrammK.Top
  Programm.Tag = "1"
  Programm.Width = ProgrammK.Width
  Programm.Tag = "1"
  Programm.Height = ProgrammK.Height
  Programm.WindowState = ProgrammK.Modus
  Bedienung.Left = BedienungK.Left
  Bedienung.Top = BedienungK.Top
 End If
 LoadRaum Verz + "LastRaum.Dat"
 LoadProgramm Verz + "LastProgramm.Dat"
 LoadLastData
 Bedienung.KillTempFiles
End Sub

Function Schreibtest() As Boolean
 On Error GoTo FalseSchreibtest
 Dim FileNum%
 Dim Temp As String
 FileNum% = FreeFile
 Open Verz + "Schreibtest.tmp" For Output As FileNum%
 Print #FileNum%, "Schreibtest"
 Close FileNum%
 Open Verz + "Schreibtest.tmp" For Input As FileNum%
 Line Input #FileNum%, Temp
 Close FileNum%
 If Not Temp = "Schreibtest" Then GoTo FalseSchreibtest
 Kill Verz + "Schreibtest.tmp"
 Schreibtest = True
 Exit Function
FalseSchreibtest:
 Schreibtest = False
 Exit Function
End Function

Function GetFeldIndex(Punkt As POINTAPI, Breite As Integer) As Integer
 GetFeldIndex = Punkt.x + Punkt.y * Breite
End Function

Function GetXY(Index As Integer, Breite As Integer) As POINTAPI
 Dim Temp As POINTAPI
 Temp.y = Int(Index / Breite)
 Temp.x = Index - Temp.y * Breite
 GetXY = Temp
End Function

Function EditNIKI() As Boolean
 Dim x As Integer
 Dim y As Integer
 For x = 0 To 9
  For y = 0 To 9
   TempBild(x, y) = PersNIKI(x, y)
  Next
 Next
 EditorCaption = "Das soll NIKI sein"
 Editor.Show 1
 If EditorEnde = False Then
  EditNIKI = False
  Exit Function
 End If
 Dim FileNum%
 Dim Temp As String
 FileNum% = FreeFile
 Open Verz + "NIKI.Dat" For Output As FileNum%
 For x = 0 To 9
  Temp = ""
  For y = 0 To 9
   Temp = Temp + IIf(TempBild(x, y), "1", "0")
   PersNIKI(x, y) = TempBild(x, y)
  Next
  Print #FileNum%, Temp
 Next
 Close FileNum%
 EditNIKI = True
End Function

Function EditPunkt() As Boolean
 Dim x As Integer
 Dim y As Integer
 For x = 0 To 9
  For y = 0 To 9
   TempBild(x, y) = EinPunkt(x, y)
  Next
 Next
 EditorCaption = "Ein Punkt"
 Editor.Show 1
 If EditorEnde = False Then
  EditPunkt = False
  Exit Function
 End If
 Dim FileNum%
 Dim Temp As String
 FileNum% = FreeFile
 Open Verz + "Punkt.Dat" For Output As FileNum%
 For x = 0 To 9
  Temp = ""
  For y = 0 To 9
   Temp = Temp + IIf(TempBild(x, y), "1", "0")
   EinPunkt(x, y) = TempBild(x, y)
  Next
  Print #FileNum%, Temp
 Next
 Close FileNum%
 EditPunkt = True
End Function

Function EditTr1() As Boolean
 Dim x As Integer
 Dim y As Integer
 For x = 0 To 9
  For y = 0 To 9
   TempBild(x, y) = BildTr1(x, y)
  Next
 Next
 EditorCaption = "Tr 1 (mindestens ein Punkt um zu passieren)"
 Editor.Show 1
 If EditorEnde = False Then
  EditTr1 = False
  Exit Function
 End If
 Dim FileNum%
 Dim Temp As String
 FileNum% = FreeFile
 Open Verz + "Tr1.Dat" For Output As FileNum%
 For x = 0 To 9
  Temp = ""
  For y = 0 To 9
   Temp = Temp + IIf(TempBild(x, y), "1", "0")
   BildTr1(x, y) = TempBild(x, y)
  Next
  Print #FileNum%, Temp
 Next
 Close FileNum%
 EditTr1 = True
End Function

Function EditTr2() As Boolean
 Dim x As Integer
 Dim y As Integer
 For x = 0 To 9
  For y = 0 To 9
   TempBild(x, y) = BildTr2(x, y)
  Next
 Next
 EditorCaption = "Tr 2 (KEIN Punkt um zu passieren)"
 Editor.Show 1
 If EditorEnde = False Then
  EditTr2 = False
  Exit Function
 End If
 Dim FileNum%
 Dim Temp As String
 FileNum% = FreeFile
 Open Verz + "Tr2.Dat" For Output As FileNum%
 For x = 0 To 9
  Temp = ""
  For y = 0 To 9
   Temp = Temp + IIf(TempBild(x, y), "1", "0")
   BildTr2(x, y) = TempBild(x, y)
  Next
  Print #FileNum%, Temp
 Next
 Close FileNum%
 EditTr2 = True
End Function

Function LoadForms() As Boolean
 If Dir$(Verz + "Form.Dat") = "" Then
  LoadForms = False
  Exit Function
 End If
 Dim Temp As String
 Dim FileNum%
 FileNum% = FreeFile
 Open Verz + "Form.Dat" For Input As FileNum%
 Line Input #FileNum%, Temp
 HauptformK.Left = Val(Temp)
 Line Input #FileNum%, Temp
 HauptformK.Top = Val(Temp)
 Line Input #FileNum%, Temp
 ProgrammK.Left = Val(Temp)
 Line Input #FileNum%, Temp
 ProgrammK.Top = Val(Temp)
 Line Input #FileNum%, Temp
 ProgrammK.Width = Val(Temp)
 Line Input #FileNum%, Temp
 ProgrammK.Height = Val(Temp)
 Line Input #FileNum%, Temp
 ProgrammK.Modus = Val(Temp)
 Line Input #FileNum%, Temp
 BedienungK.Left = Val(Temp)
 Line Input #FileNum%, Temp
 BedienungK.Top = Val(Temp)
 Line Input #FileNum%, Temp
 EditorBedienungK.Left = Val(Temp)
 Line Input #FileNum%, Temp
 EditorBedienungK.Top = Val(Temp)
 Close FileNum%
 LoadForms = True
End Function

Sub SaveForms()
 Dim FileNum%
 FileNum% = FreeFile
 Open Verz + "Form.Dat" For Output As FileNum%
 Print #FileNum%, Str$(HauptformK.Left)
 Print #FileNum%, Str$(HauptformK.Top)
 Print #FileNum%, Str$(ProgrammK.Left)
 Print #FileNum%, Str$(ProgrammK.Top)
 Print #FileNum%, Str$(ProgrammK.Width)
 Print #FileNum%, Str$(ProgrammK.Height)
 Print #FileNum%, Str$(ProgrammK.Modus)
 Print #FileNum%, Str$(BedienungK.Left)
 Print #FileNum%, Str$(BedienungK.Top)
 Print #FileNum%, Str$(EditorBedienungK.Left)
 Print #FileNum%, Str$(EditorBedienungK.Top)
 Close FileNum%
End Sub

Function SaveRaum(Datei As String) As Boolean
 On Error GoTo ErrorSaveRaum
 Dim FileNum%
 Dim x As Integer
 FileNum% = FreeFile
 Open Datei For Output As FileNum%
 For x = 0 To 20 * 20 - 1
  Print #FileNum%, Hauptform.Feld(x).Tag
 Next
 For x = 0 To 19 * 20 - 1
  Print #FileNum%, IIf(Hauptform.LinksRechts(x).BackColor = 0, "1", "0")
 Next
 For x = 0 To 19 * 20 - 1
  Print #FileNum%, IIf(Hauptform.ObenUnten(x).BackColor = 0, "1", "0")
 Next
 Print #FileNum%, IIf(MainData.Ziel.Standort, "1", "0")
 Print #FileNum%, IIf(MainData.Ziel.Punkte, "1", "0")
 Print #FileNum%, IIf(MainData.Ziel.NewRaum, "1", "0")
 Print #FileNum%, Str$(MainData.Ziel.DataStandort.x)
 Print #FileNum%, Str$(MainData.Ziel.DataStandort.y)
 Print #FileNum%, Str$(MainData.Ziel.DataPunkte)
 Print #FileNum%, MainData.Ziel.DataNewRaum
 Print #FileNum%, Str$(MainData.Mnnchen.Richtung)
 Print #FileNum%, Str$(MainData.Mnnchen.Standort.x)
 Print #FileNum%, Str$(MainData.Mnnchen.Standort.y)
 Close FileNum%
 SaveRaum = True
 Exit Function
ErrorSaveRaum:
 SaveRaum = False
 Exit Function
End Function

Function LoadRaum(Datei As String) As Boolean
 On Error GoTo ErrorLoadRaum
 Dim FileNum%
 Dim Temp As String
 Dim x As Integer
 Dim Punkt As POINTAPI
 FileNum% = FreeFile
 Open Datei For Input As FileNum%
 MainData.Mnnchen.AnzPunkte = 0
 If Not Hauptform.Editirmodus.Checked Then
  Bedienung.Label3.Caption = "0"
 End If
 For x = 0 To 20 * 20 - 1
  Line Input #FileNum%, Temp
  Hauptform.Feld(x).Tag = Temp
  If Temp = "NIKI" Then
   Punkt = GetXY(x, 20)
   MainData.Mnnchen.Standort = Punkt
  End If
 Next
 For x = 0 To 19 * 20 - 1
  Line Input #FileNum%, Temp
  Hauptform.LinksRechts(x).BackColor = IIf(Temp = "1", 0, RGB(200, 200, 200))
 Next
 For x = 0 To 19 * 20 - 1
  Line Input #FileNum%, Temp
  Hauptform.ObenUnten(x).BackColor = IIf(Temp = "1", 0, RGB(200, 200, 200))
 Next
 Line Input #FileNum%, Temp
 MainData.Ziel.Standort = (Temp = "1")
 Line Input #FileNum%, Temp
 MainData.Ziel.Punkte = (Temp = "1")
 Line Input #FileNum%, Temp
 MainData.Ziel.NewRaum = (Temp = "1")
 Line Input #FileNum%, Temp
 MainData.Ziel.DataStandort.x = Val(Temp)
 Line Input #FileNum%, Temp
 MainData.Ziel.DataStandort.y = Val(Temp)
 Line Input #FileNum%, Temp
 MainData.Ziel.DataPunkte = Val(Temp)
 Line Input #FileNum%, Temp
 MainData.Ziel.DataNewRaum = Temp
 Line Input #FileNum%, Temp
 MainData.Mnnchen.Richtung = Val(Temp)
 Line Input #FileNum%, Temp
 MainData.Mnnchen.Standort.x = Val(Temp)
 Line Input #FileNum%, Temp
 MainData.Mnnchen.Standort.y = Val(Temp)
 Close FileNum%
 For x = 0 To 20 * 20 - 1
  Hauptform.Feld_Paint x
 Next
 LoadRaum = True
 Exit Function
ErrorLoadRaum:
 LoadRaum = False
 Exit Function
End Function

Function SaveProgramm(Datei As String) As Boolean
 On Error GoTo ErrorSaveProgramm
 Dim FileNum%
 FileNum% = FreeFile
 Open Datei For Output As FileNum%
 Print #FileNum%, Programm.Text1.Text
 Close FileNum%
 SaveProgramm = True
 Exit Function
ErrorSaveProgramm:
 SaveProgramm = False
 Exit Function
End Function

Function LoadProgramm(Datei As String) As Boolean
 On Error GoTo ErrorLoadProgramm
 Dim FileNum%
 Dim Temp As String
 FileNum% = FreeFile
 Open Datei For Input As FileNum%
 Programm.Text1.Text = ""
 Do While Not EOF(FileNum%)
  Line Input #FileNum%, Temp
  Programm.Text1.Text = Programm.Text1.Text + IIf(Programm.Text1.Text = "", "", Chr$(13) + Chr$(10)) + Temp
 Loop
 Close FileNum%
 LoadProgramm = True
 Exit Function
ErrorLoadProgramm:
 LoadProgramm = False
 Exit Function
End Function

Sub SaveLastData()
 On Error Resume Next
 Dim FileNum%
 FileNum% = FreeFile
 Open Verz + "Last.Dat" For Output As FileNum%
 Print #FileNum%, Hauptform.CDRaum.Tag
 Print #FileNum%, Hauptform.CDProgramm.Tag
 Print #FileNum%, Bedienung.Label1.Caption
 Close FileNum%
End Sub

Sub LoadLastData()
 On Error Resume Next
 Dim FileNum%
 Dim Temp As String
 FileNum% = FreeFile
 Open Verz + "Last.Dat" For Input As FileNum%
 Line Input #FileNum%, Temp
 Hauptform.CDRaum.Tag = Temp
 Line Input #FileNum%, Temp
 Hauptform.CDProgramm.Tag = Temp
 Line Input #FileNum%, Temp
 Bedienung.HScroll1.Value = Val(Temp)
 Close FileNum%
 Hauptform.ShowCaption
 Programm.ShowCaption
End Sub

Sub SaveSecurity()
 SaveProgramm Verz + "LastProgramm.Dat"
 SaveRaum Verz + "LastRaum.Dat"
 SaveLastData
End Sub

Function CommandVor() As Boolean
 Dim Fehler As Boolean
 Dim Punkt As POINTAPI
 Fehler = False
 Select Case MainData.Mnnchen.Richtung
  Case 1
   If MainData.Mnnchen.Standort.y = 0 Then
    MsgBox "Niki ist gegen eine Wand gelaufen.", , "Fehler"
    Fehler = True
   Else
    Punkt = MainData.Mnnchen.Standort
    Punkt.y = Punkt.y - 1
    If Hauptform.LinksRechts(GetFeldIndex(Punkt, 20)).BackColor = 0 Then
     MsgBox "Niki ist gegen eine Wand gelaufen.", , "Fehler"
     Fehler = True
    Else
     If MainData.Mnnchen.AnzPunkte = 0 Then
      If Hauptform.Feld(GetFeldIndex(Punkt, 20)).Tag = "Tr1" Then
       MsgBox "Niki braucht mindestens 1 Punkt, um diese Tr zu passieren.", , "Fehler"
       Fehler = True
       GoTo Unten
      End If
     Else
      If Hauptform.Feld(GetFeldIndex(Punkt, 20)).Tag = "Tr2" Then
       MsgBox "Niki darf keinen Punkt besitzen, um diese Tr zu passieren.", , "Fehler"
       Fehler = True
       GoTo Unten
      End If
     End If
     MainData.Mnnchen.Standort = Punkt
     Punkt.y = Punkt.y + 1
     Hauptform.Feld_Paint GetFeldIndex(Punkt, 20)
     Hauptform.Feld_Paint GetFeldIndex(MainData.Mnnchen.Standort, 20)
    End If
   End If
  Case 2
   If MainData.Mnnchen.Standort.x = 19 Then
    MsgBox "Niki ist gegen eine Wand gelaufen.", , "Fehler"
    Fehler = True
   Else
    Punkt = MainData.Mnnchen.Standort
    If Hauptform.ObenUnten(GetFeldIndex(Punkt, 19)).BackColor = 0 Then
     MsgBox "Niki ist gegen eine Wand gelaufen.", , "Fehler"
     Fehler = True
    Else
     Punkt.x = Punkt.x + 1
     If MainData.Mnnchen.AnzPunkte = 0 Then
      If Hauptform.Feld(GetFeldIndex(Punkt, 20)).Tag = "Tr1" Then
       MsgBox "Niki braucht mindestens 1 Punkt, um diese Tr zu passieren.", , "Fehler"
       Fehler = True
       GoTo Unten
      End If
     Else
      If Hauptform.Feld(GetFeldIndex(Punkt, 20)).Tag = "Tr2" Then
       MsgBox "Niki darf keinen Punkt besitzen, um diese Tr zu passieren.", , "Fehler"
       Fehler = True
       GoTo Unten
      End If
     End If
     MainData.Mnnchen.Standort = Punkt
     Punkt.x = Punkt.x - 1
     Hauptform.Feld_Paint GetFeldIndex(Punkt, 20)
     Hauptform.Feld_Paint GetFeldIndex(MainData.Mnnchen.Standort, 20)
    End If
   End If
  Case 3
   If MainData.Mnnchen.Standort.y = 19 Then
    MsgBox "Niki ist gegen eine Wand gelaufen.", , "Fehler"
    Fehler = True
   Else
    Punkt = MainData.Mnnchen.Standort
    If Hauptform.LinksRechts(GetFeldIndex(Punkt, 20)).BackColor = 0 Then
     MsgBox "Niki ist gegen eine Wand gelaufen.", , "Fehler"
     Fehler = True
    Else
     Punkt.y = Punkt.y + 1
     If MainData.Mnnchen.AnzPunkte = 0 Then
      If Hauptform.Feld(GetFeldIndex(Punkt, 20)).Tag = "Tr1" Then
       MsgBox "Niki braucht mindestens 1 Punkt, um diese Tr zu passieren.", , "Fehler"
       Fehler = True
       GoTo Unten
      End If
     Else
      If Hauptform.Feld(GetFeldIndex(Punkt, 20)).Tag = "Tr2" Then
       MsgBox "Niki darf keinen Punkt besitzen, um diese Tr zu passieren.", , "Fehler"
       Fehler = True
       GoTo Unten
      End If
     End If
     MainData.Mnnchen.Standort = Punkt
     Punkt.y = Punkt.y - 1
     Hauptform.Feld_Paint GetFeldIndex(Punkt, 20)
     Hauptform.Feld_Paint GetFeldIndex(MainData.Mnnchen.Standort, 20)
    End If
   End If
  Case 4
   If MainData.Mnnchen.Standort.x = 0 Then
    MsgBox "Niki ist gegen eine Wand gelaufen.", , "Fehler"
    Fehler = True
   Else
    Punkt = MainData.Mnnchen.Standort
    Punkt.x = Punkt.x - 1
    If Hauptform.ObenUnten(GetFeldIndex(Punkt, 19)).BackColor = 0 Then
     MsgBox "Niki ist gegen eine Wand gelaufen.", , "Fehler"
     Fehler = True
    Else
     If MainData.Mnnchen.AnzPunkte = 0 Then
      If Hauptform.Feld(GetFeldIndex(Punkt, 20)).Tag = "Tr1" Then
       MsgBox "Niki braucht mindestens 1 Punkt, um diese Tr zu passieren.", , "Fehler"
       Fehler = True
       GoTo Unten
      End If
     Else
      If Hauptform.Feld(GetFeldIndex(Punkt, 20)).Tag = "Tr2" Then
       MsgBox "Niki darf keinen Punkt besitzen, um diese Tr zu passieren.", , "Fehler"
       Fehler = True
       GoTo Unten
      End If
     End If
     MainData.Mnnchen.Standort = Punkt
     Punkt.x = Punkt.x + 1
     Hauptform.Feld_Paint GetFeldIndex(Punkt, 20)
     Hauptform.Feld_Paint GetFeldIndex(MainData.Mnnchen.Standort, 20)
    End If
   End If
 End Select
Unten:
 CommandVor = (Fehler = False)
End Function

Function CommandNimm_auf() As Boolean
 If Not Hauptform.Feld(GetFeldIndex(MainData.Mnnchen.Standort, 20)).Tag = "Punkt" Then
  MsgBox "Niki kann hier keinen Punkt aufsammeln, da hier kein Punkt ist.", , "Fehler"
  CommandNimm_auf = False
 Else
  Hauptform.Feld(GetFeldIndex(MainData.Mnnchen.Standort, 20)).Tag = ""
  MainData.Mnnchen.AnzPunkte = MainData.Mnnchen.AnzPunkte + 1
  Bedienung.Label3.Caption = LTrim$(RTrim$(Str$(MainData.Mnnchen.AnzPunkte)))
  CommandNimm_auf = True
 End If
End Function

Function CommandGib_ab() As Boolean
 If MainData.Mnnchen.AnzPunkte = 0 Then
  MsgBox "Niki hat im Moment keine Punkte zum ablegen.", , "Fehler"
  CommandGib_ab = False
  Exit Function
 End If
 Select Case Hauptform.Feld(GetFeldIndex(MainData.Mnnchen.Standort, 20)).Tag
  Case "Punkt"
   MsgBox "Niki kann hier kein Punkt hinlegen, da hier bereits ein Punkt liegt.", , "Fehler"
   CommandGib_ab = False
  Case ""
   Hauptform.Feld(GetFeldIndex(MainData.Mnnchen.Standort, 20)).Tag = "Punkt"
   MainData.Mnnchen.AnzPunkte = MainData.Mnnchen.AnzPunkte - 1
   Bedienung.Label3.Caption = LTrim$(RTrim$(Str$(MainData.Mnnchen.AnzPunkte)))
   CommandGib_ab = True
  Case Else
   MsgBox "Niki kann in einer Tr keinen Punkt ablegen.", , "Fehler"
   CommandGib_ab = False
 End Select
End Function

Function TestZielEreicht() As Boolean
 If MainData.Ziel.Standort Then
  If Not TestGleich(MainData.Mnnchen.Standort, MainData.Ziel.DataStandort) Then
   TestZielEreicht = False
   Exit Function
  End If
 End If
 If MainData.Ziel.Punkte Then
  If Not MainData.Mnnchen.AnzPunkte = MainData.Ziel.DataPunkte Then
   TestZielEreicht = False
   Exit Function
  End If
 End If
 If MainData.Ziel.NewRaum Then
  If LoadRaum(MainData.Ziel.DataNewRaum) = False Then
   MsgBox "Das Ziel des aktuellen Raums wurde erreicht. Das Ziel wurde so definiert, das jetzt der Raum + " + Chr$(34) + MainData.Ziel.DataNewRaum + Chr$(34) + " geladen werden sollte. Beim Laden dieses Raumes ist ein Fehler aufgetreten.", , "Fehler"
   TestZielEreicht = True
  Else
   TestZielEreicht = False
  End If
  Exit Function
 End If
 MsgBox "Niki hat das Ziel ereicht!", , "Hinweis"
 TestZielEreicht = True
End Function

Function TestGleich(Punkt1 As POINTAPI, Punkt2 As POINTAPI) As Boolean
 If (Punkt1.x = Punkt2.x) And (Punkt1.y = Punkt2.y) Then
  TestGleich = True
 Else
  TestGleich = False
 End If
End Function
